<?php  
            include_once( $_SERVER['DOCUMENT_ROOT']."/static/includes/common.inc.php" );
            do_html_header("Documentation");
        ?><div id="content">
<div class="navheader">
<table width="100%" summary="Navigation header"><tr>
<td width="20%" align="left">
<a accesskey="p" href="pegasuslite.php">Prev</a> </td>
<td width="60%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="20%" align="right"> <a accesskey="n" href="BasicProperties.php">Next</a>
</td>
</tr></table>
<hr>
</div>
<div class="section" title="5.5. Pegasus-Plan">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="pegasus-plan"></a>5.5. Pegasus-Plan</h2></div></div></div>
<p>pegasus-plan is the main executable that takes in the abstract
    workflow ( DAX ) and generates an executable workflow ( usually a Condor
    DAG ) by querying various catalogs and performing several refinement
    steps. Before users can run pegasus plan the following needs to be
    done:</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem">
<p>Populate the various catalogs</p>
<div class="orderedlist"><ol class="orderedlist" type="a">
<li class="listitem">
<p><span class="bold"><strong>Replica Catalog</strong></span></p>
<p>The Replica Catalog needs to be catalogued with the
            locations of the input files required by the workflows. This can
            be done by using pegasus-rc-client (See the Replica section of
            <a class="link" href="creating_workflows.php" title="Chapter 4. Creating Workflows">Creating
            Workflows</a>).</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Transformation
            Catalog</strong></span></p>
<p>The Transformation Catalog needs to be catalogued with the
            locations of the executables that the workflows will use. This can
            be done by using pegasus-tc-client (See the Transformation section
            of <a class="link" href="creating_workflows.php" title="Chapter 4. Creating Workflows">Creating
            Workflows</a>).</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Site Catalog</strong></span></p>
<p>The Site Catalog needs to be catalogued with the site layout
            of the various sites that the workflows can execute on. A site
            catalog can be generated for OSG by using the client
            pegasus-sc-client (See the Site section of the <a class="link" href="creating_workflows.php" title="Chapter 4. Creating Workflows">Creating Workflows</a>).</p>
</li>
</ol></div>
</li>
<li class="listitem">
<p>Configure Properties</p>
<p>After the catalogs have been configured, the user properties
        file need to be updated with the types and locations of the catalogs
        to use. These properties are described in the <span class="bold"><strong>basic.properties</strong></span> files in the <span class="bold"><strong>etc</strong></span> sub directory (see the Properties section
        of the<a class="link" href="configuration.php" title="Chapter 12. Configuration"> Configuration</a>
        chapter.</p>
<p>The basic properties that need to be set usually are listed
        below:</p>
<div class="table">
<a name="idp16068272"></a><p class="title"><b>Table 5.2. Table2: Basic Properties that need to be set</b></p>
<div class="table-contents"><table summary="Table2: Basic Properties that need to be set" border="1">
<colgroup><col></colgroup>
<tbody>
<tr><td>pegasus.catalog.replica</td></tr>
<tr><td>pegasus.catalog.replica.file |
                pegasus.catalog.replica.url</td></tr>
<tr><td>pegasus.catalog.transformation</td></tr>
<tr><td>pegasus.catalog.transformation.file</td></tr>
<tr><td>pegasus.catalog.site.file</td></tr>
</tbody>
</table></div>
</div>
<br class="table-break">
</li>
</ol></div>
<p>To execute pegasus-plan user usually requires to specify the
    following options:</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p><span class="bold"><strong>--dax </strong></span> the path to the DAX file
        that needs to be mapped.</p></li>
<li class="listitem"><p><span class="bold"><strong>--dir </strong></span> the base directory where
        the executable workflow is generated</p></li>
<li class="listitem"><p><span class="bold"><strong>--sites </strong></span> comma separated list
        of execution sites.</p></li>
<li class="listitem"><p><span class="bold"><strong>--output</strong></span> the output site where
        to transfer the materialized output files.</p></li>
<li class="listitem"><p><span class="bold"><strong>--submit </strong></span> boolean value whether
        to submit the planned workflow for execution after planning is
        done.</p></li>
</ol></div>
</div>
<div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="pegasuslite.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="running_workflows.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="BasicProperties.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">5.4. PegasusLite </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 5.6. Basic Properties</td>
</tr>
</table>
</div>
</div><?php  
            do_html_footer();
        ?>
